Loading...
Searching...
No Matches
Sip_unsupported

## Macros

#define | sip_unsupported(sip)
| Access a SIP Unsupported header structure sip_unsupported_t from sip_t.
#define | SIP_UNSUPPORTED_INIT()
| Initializer for structure sip_unsupported_t.
#define | SIPTAG_UNSUPPORTED(x)
| Tag list item for pointer to a Unsupported header structure sip_unsupported_t.
#define | SIPTAG_UNSUPPORTED_REF(x)
| Tag list item for reference to a Unsupported header pointer.
#define | SIPTAG_UNSUPPORTED_STR(s)
| Tag list item for string with Unsupported header value.
#define | SIPTAG_UNSUPPORTED_STR_REF(x)
| Tag list item for reference to a Unsupported header string.

## Typedefs

typedef msg_list_t | sip_unsupported_t
| @

## Functions

issize_t | sip_unsupported_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Unsupported header.
issize_t | sip_unsupported_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Unsupported header.
sip_unsupported_t * | sip_unsupported_init (sip_unsupported_t x[1])
| Initialize a structure sip_unsupported_t.
int | sip_is_unsupported (sip_header_t const *header)
| Test if header object is instance of sip_unsupported_t.
sip_unsupported_t * | sip_unsupported_dup (su_home_t *home, sip_unsupported_t const *hdr))
| Duplicate a list of Unsupported header header structures sip_unsupported_t.
sip_unsupported_t * | sip_unsupported_copy (su_home_t *home, sip_unsupported_t const *hdr))
| Copy a list of Unsupported header header structures sip_unsupported_t.
sip_unsupported_t * | sip_unsupported_make (su_home_t *home, char const *s))
| Make a Unsupported header structure sip_unsupported_t.
sip_unsupported_t * | sip_unsupported_format (su_home_t *home, char const *fmt,...)))
| Make a Unsupported header from formatting result.

## Variables

msg_hclass_t | sip_unsupported_class []
| Header class for Unsupported header.
tag_typedef_t | siptag_unsupported
| Tag for Unsupported header object.
tag_typedef_t | siptag_unsupported_str
| Tag for string with Unsupported header value.

## Detailed Description

## Macro Definition Documentation

## SIP_UNSUPPORTED_INIT

#define SIP_UNSUPPORTED_INIT | ( |  | ) |

Initializer for structure sip_unsupported_t.

A static sip_unsupported_t structure for Unsupported header must be initialized with the SIP_UNSUPPORTED_INIT() macro. For instance,

sip_unsupported_t sip_unsupported = SIP_UNSUPPORTED_INIT;
SIP_UNSUPPORTED_INIT
#define SIP_UNSUPPORTED_INIT()
Initializer for structure sip_unsupported_t.
Definition sip_protos.h:8478
sip_unsupported
#define sip_unsupported(sip)
Access a SIP Unsupported header structure sip_unsupported_t from sip_t.
Definition sip_protos.h:8461
sip_unsupported_t
msg_list_t sip_unsupported_t
@
Definition sip.h:198

## SIPTAG_UNSUPPORTED

#define SIPTAG_UNSUPPORTED | ( |  | x | ) |

Tag list item for pointer to a Unsupported header structure sip_unsupported_t.

The SIPTAG_UNSUPPORTED() macro is used to include a tag item with a pointer to a sip_unsupported_t structure in a tag list.

Parameters

  x | pointer to a sip_unsupported_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_UNSUPPORTED_REF().

## SIPTAG_UNSUPPORTED_STR

#define SIPTAG_UNSUPPORTED_STR | ( |  | s | ) |

Tag list item for string with Unsupported header value.

The SIPTAG_UNSUPPORTED_STR() macro is used to include a tag item with a string containing value of a sip_unsupported_t header in a tag list.

Parameters

  s | pointer to a string containing Unsupported header value, or NULL.

The string in SIPTAG_UNSUPPORTED_STR() can be converted to a sip_unsupported_t header structure by giving the string s has second argument to function sip_unsupported_make().

The corresponding tag taking reference parameter is SIPTAG_UNSUPPORTED_STR_REF().

## Typedef Documentation

## sip_unsupported_t

typedef msg_list_t sip_unsupported_t

@

The Unsupported header lists the features not supported by the server. Its syntax is defined in RFC 3261 as follows:

Unsupported = "Unsupported" HCOLON [option-tag *(COMMA option-tag)]

The parsed Unsupported header is stored in sip_unsupported_t structure.

The structure sip_unsupported_t contains representation of an Unsupported header.

The sip_unsupported_t is defined as follows:

typedef struct msg_list_s
{
msg_common_t k_common[1]; // Common fragment info
msg_list_t *k_next; // Link to next header
msg_param_t *k_items; // List of items
} sip_unsupported_t;
msg_list_t
struct msg_list_s msg_list_t
msg_common_t
struct msg_common_s msg_common_t
msg_list_s
msg_list_s::k_common
msg_common_t k_common[1]
msg_list_s::k_next
msg_list_t * k_next
msg_list_s::k_items
msg_param_t * k_items

## Function Documentation

## sip_is_unsupported()

int sip_is_unsupported | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_unsupported_t.

Check if the header class is an instance of Unsupported header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header unsupported
  0 | (false) otherwise

## sip_unsupported_copy()

sip_unsupported_t * sip_unsupported_copy | ( | su_home_t * | home,
|  | sip_unsupported_t const * | hdr )

inline

Copy a list of Unsupported header header structures sip_unsupported_t.

The function sip_unsupported_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  unsupported = sip_unsupported_copy(home, sip->sip_unsupported);
  sip_unsupported_copy
  sip_unsupported_t * sip_unsupported_copy(su_home_t *home, sip_unsupported_t const *hdr))
  Copy a list of Unsupported header header structures sip_unsupported_t.
  Definition sip_protos.h:8608

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_unsupported_dup()

sip_unsupported_t * sip_unsupported_dup | ( | su_home_t * | home,
|  | sip_unsupported_t const * | hdr )

inline

Duplicate a list of Unsupported header header structures sip_unsupported_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  unsupported = sip_unsupported_dup(home, sip->sip_unsupported);
  sip_unsupported_dup
  sip_unsupported_t * sip_unsupported_dup(su_home_t *home, sip_unsupported_t const *hdr))
  Duplicate a list of Unsupported header header structures sip_unsupported_t.
  Definition sip_protos.h:8565

Returns
  A pointer to the newly duplicated sip_unsupported_t header structure, or NULL upon an error.

## sip_unsupported_format()

sip_unsupported_t * sip_unsupported_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Unsupported header from formatting result.

Make a new sip_unsupported_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_unsupported_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_unsupported_init()

sip_unsupported_t * sip_unsupported_init | ( | sip_unsupported_t | x[1] | ) |

inline

Initialize a structure sip_unsupported_t.

An sip_unsupported_t structure for Unsupported header can be initialized with the sip_unsupported_init() function/macro. For instance,

sip_unsupported_t sip_unsupported;
sip_unsupported_init(&sip_unsupported);
sip_unsupported_init
sip_unsupported_t * sip_unsupported_init(sip_unsupported_t x[1])
Initialize a structure sip_unsupported_t.
Definition sip_protos.h:8496

## sip_unsupported_make()

sip_unsupported_t * sip_unsupported_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Unsupported header structure sip_unsupported_t.

The function sip_unsupported_make() makes a new sip_unsupported_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_unsupported_t header structure, or NULL upon an error.

## Variable Documentation

## sip_unsupported_class

msg_hclass_t sip_unsupported_class[]

extern

Header class for Unsupported header.

The header class sip_unsupported_class defines how a SIP Unsupported header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_unsupported_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.